#!/usr/bin/env ruby
###########################################################################
###########################################################################
##  Copyright The Resistance (C) 1995-2011                               ##
##  Author: blass                                                        ##
##  blass[at]sdf.lonestar.org                                            ##
##  Badass 0.2 Beta                                                      ##
##  This file is part of Badass.                                         ##
##  Badass is free software: you can redistribute it and/or modify       ##
##  it under the terms of the GNU General Public License as published by ##
##  the Free Software Foundation, either version 3 of the License, or    ##
##  (at your option) any later version.                                  ##
##  Badass is distributed in the hope that it will be useful,            ##
##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
##  GNU General Public License for more details.                         ##
##  You should have received a copy of the GNU General Public License    ##
##  along with Badass. If not, see http://www.gnu.org/licenses/          ##
###########################################################################
###########################################################################

module Racket
  module L3
    # Exterior Gateway protocol (EGP)
    # http://tools.ietf.org/html/rfc904
    # XXX: TODO, add support for tacking on the various message types
    class EGP < RacketPart
      # EGP version
      unsigned :version, 8
      # Message type
      unsigned :type, 8
      # Message code (subtype)
      unsigned :code, 8
      # Message dependent status information
      unsigned :status, 8
      # Checksum
      unsigned :checksum, 16
      # assigned number identifying the particular autonomous system
      unsigned :asn, 16
      # Sequence number
      unsigned :sequence, 16
      # Payload
      rest :payload
    end
  end
end
# vim: set ts=2 et sw=2:
